﻿clearlistener()
struct vpt_tex_info (
	id = 0,
	addr = 0,
	size = 0
	)
struct vpt_tex_dim (
	width = 0,
	height = 0,
	config = 0		-- 3 = Image + palette Data | 5 = ?same as 3 | 15 = palette Data
	)
struct vpt_file (
	file_start_pos = 0,
	filetype = 0,	-- 0x00040403
	unk01 = 0,
	texture_count = 0,
	unk02 = 0,
	unk03 = 0,
	addr1 = 0,		-- goes to a sub header at the end of the file
	addr2 = 0,		-- goes to a table at the end of the file
	addr3 = 0,		-- goes to a checksum? at the end of the file
	addr4 = 0,		-- same as previous, checksum?
	pad1 = 0,		-- always 0?
	pad2 = 0,		-- always 0?
	table1 = #(),	-- contains addresses to table 2
	table2 = #(),
	table3 = #(),
	table4 = #(),	-- addresses don't quite make sense, probably reading it wrong
	fn read_vpt_file &f = (
		local i = 1, tmp = #(), chunkid = 0, cont = true, index = 0
		local table4_end_pos = 0, table2_end_pos = 0
		
		file_start_pos = ftell f -- will be 0, unless file is embedded
		filetype = readlong f #unsigned
		if filetype == 0x00040403 then (
			
			-- read header
			unk01 = readbyte f #unsigned
			texture_count = readbyte f #unsigned
			unk02 = readbyte f #unsigned
			unk03 = readbyte f #unsigned
			addr1 = (readlong f #unsigned) + file_start_pos
			addr2 = (readlong f #unsigned) + file_start_pos
			addr3 = (readlong f #unsigned) + file_start_pos
			addr4 = (readlong f #unsigned) + file_start_pos
			pad1 = readlong f #unsigned
			pad2 = readlong f #unsigned
			
			
			-- reading of the tables is sketchy, not entirely sure how to 
			-- parse it correctly, so having to scan around for stuff
			
			-- read table1, get addresses for table2
			fseek f (file_start_pos + 0x24) #seek_set
			if texture_count > 0 do table1[texture_count] = 0
			for i = 1 to texture_count do (
				table1[i] = (readlong f #unsigned) + file_start_pos
				fseek f 0x0C #seek_cur
				)
			
			-- attempt to parse table2, got no idea how it works tho
			for i = 1 to texture_count do (
				tmp = #()
				if table1[i] > file_start_pos do (
					fseek f table1[i] #seek_set
					cont = true
					index = 0
					while cont do (
						chunkid = readshort f #unsigned
						case chunkid of (
							0x0000: (
								cont = false
								fseek f 0x0E #seek_cur
								if ftell f > table2_end_pos do table2_end_pos == ftell f
								)
							0x0004: (fseek f 0x06 #seek_cur)
							0x0006: (
								index += 1
								fseek f 0x05 #seek_cur
								append tmp (vpt_tex_info size:(readlong f #unsigned))
								fseek f 0x05 #seek_cur
								)
							0x000E: (
								fseek f 0x0A #seek_cur
								tmp[index].id = readlong f #unsigned
								)
							0x0050: (fseek f 0x0E #seek_cur)
							0x0051: (fseek f 0x0E #seek_cur)
							0x0052: (fseek f 0x0E #seek_cur)
							0x0053: (
								fseek f 0x1A #seek_cur
								tmp[index].addr = (readlong f #unsigned) + file_start_pos
								fseek f 0x08 #seek_cur
								)
							default: (
								format "Unknown ID @\t0x%\n" \
									(bit.intAsHex ((ftell f) as integer))
								cont = false
								)
							)
						)
					)
				append table2 tmp
				)
			
			-- read table4?
			fseek f addr2 #seek_set
			if texture_count > 0 do table4[texture_count] = 0
			for i = 1 to texture_count do (
				table4[i] = (readlong f #unsigned) + file_start_pos
				)
			
			-- alt way of reading table 3
			if texture_count > 0 do table3[texture_count] = vpt_tex_dim()
			for i = 1 to texture_count do (
				table3[i] = vpt_tex_dim()
				if table4[i] > file_start_pos then (
					table3[i].config = mod table4[i] 16
					format "%\t%\n" i table3[i].config
					fseek f (table4[i] - table3[i].config) #seek_set
					fseek f 0x0C #seek_cur
					format "Location %:\t0x%\n" i (bit.intAsHex ((ftell f) as integer))
					table3[i].width = readshort f #unsigned
					table3[i].height = readshort f #unsigned
					) else (format "skipped %\n" i)
				)
			) else (format "Wrong File Type\n")
		)
	)
fn unswizzle_8bit Swizzled& Width Height = ( -- PSMT8
	local Buf = #()
	local y = 1, x = 1, block_location = 0, byte_num = 0
	local swap_selector = 0, posY = 0, column_location = 0
	
	Buf[Swizzled.count] = 0
	for y = 1 to Height do (
		for x = 1 to Width do (
			block_location = (bit.and (y - 1) -16) * Width + (bit.and (x - 1) -16) * 2
			swap_selector = (bit.and (bit.shift (y + 1) -2) 0x1) * 4
			posY = bit.and ((bit.shift (bit.and (y - 1) -4) -1) + (bit.and (y - 1) 1)) 0x7
			column_location = posY * Width * 2 + (bit.and ((x - 1) + swap_selector) 0x7) * 4
			
			byte_num = (bit.and (bit.shift (y - 1) -1) 1) + (bit.and (bit.shift (x - 1) -2) 2)
			
			Buf[((y - 1) * Width) + x] = Swizzled[block_location + column_location + byte_num + 1]
			)
		)
	Buf
	)
fn correct_clut &palette = (
	local i = 1, vb = white, vSum = 0, storeAddr = 0
	local CurrOfs = 1, ResultPal = #()
	
	ResultPal[palette.count] = white
	for i = 1 to palette.count do (ResultPal[i] = white)
	
    for i = 1 to palette.count - 1 do (
		vSum = (
			case (mod (((i - 1) / 8) as integer) 4) of (
				1: 8
				2: -8
				default: 0
				)
			)
        storeAddr = (i - 1) + vSum + 1
        ResultPal[storeAddr].red = palette[CurrOfs].red
        ResultPal[storeAddr].green =  palette[CurrOfs].green
		ResultPal[storeAddr].blue =  palette[CurrOfs].blue
		ResultPal[storeAddr].alpha =  palette[CurrOfs].alpha
		CurrOfs += 1
		)
	ResultPal
	)
fn correctGamma c gamma:2.2 = (
-- 	local f = c / 255.0
-- 	if f <= 0.03928 then (
-- 		(f / 12.92) * 255.0
-- 		)
-- 	else (
-- 		(pow ((f + 0.055) / (1.0 + 0.055)) gamma) * 255.0
-- 		)
	((pow (c / 255) gamma) * 255)
	)



fn BoolSwitch input = (
    if Input == 0 then (
		input+=1
		)
	else if input == 1 do (
		input-=1
		)
	)
fn QImage_IMGD_Parse8 &data &colors width height = (
	local i = 1, x = 1, y = 1, OutputIMG = #(), pixel = 1
	local i = 1, index = 0, remainder = 0, indexes = #()
	
	indexes[data.count] = 0
	for i = 1 to data.count do (
		index = data[i]
        
        remainder = mod index 32
		
        if remainder > 7 and remainder < 16 then (
            indexes[i] = (index + 8)
			)
        else if remainder > 15 and remainder < 24 then (
			indexes[i] = (Index - 8)
			)
        else (
			indexes[i] = index
			)
		)
	
	OutputIMG[width * height] = white
	
    for y = 1 to height do (
		for x = 1 to width do (
			i = indexes[pixel] + 1
			OutputIMG[pixel] = colors[i]
			pixel+=1
			)
		)
	
	OutputIMG
	)
fn QImage_IMGD_Decode8 &pixels &Width =  (
	local PixelList = #()

    local TrueX = 0
    local TrueY = 0

    local BoolY = 0
    local BoolPixel = 0
	local p = 0, x = 0, y = 0
	
	local TruePixel = 0
	local cp = 0, a = 0
	
	PixelList[pixels.count] = white
	for p = 1 to pixels.count do (PixelList[p] = white)
	
	for p = 0 to (pixels.count - 1) do (
        if p != 0 do (
            if (mod p (Width * 2)) == 0 then (
                case BoolY of (
                    0: (
                        TrueY += 1
						)
                    1: (
                        TrueY += 3
                        BoolPixel = BoolSwitch(BoolPixel)
						)
					)
				
                TrueX = 0
                BoolY = BoolSwitch(BoolY)
				)
            else if (mod p 32) == 0 do (
				TrueX += 16
				)
			)
		
        x = TrueX
        y = TrueY
		
        TruePixel = mod p 16
        cp = mod (p / 16) 2
		
        if BoolPixel == 1 do (
			cp = BoolSwitch(cp)
			)
		
        case cp of (
            0: (
                x = TrueX + ((mod TruePixel 4) * 4) + (TruePixel / 4)
				)
            1: (
                a = 4
                if (mod TruePixel 4) >= 2 do (
					a = 12
					)
                x = TrueX + (a - ((mod TruePixel 2) * 4)) + (TruePixel / 4)
				)
			)
		
        if mod p 2 == 1 do (
			y = TrueY + 2
			)
		PixelList[(y * Width) + x + 1] = pixels[p + 1]
		)
	PixelList
	)


fn main file = (
	local f = undefined, vpt = vpt_file(), i = 1
	local b = undefined, pal = #(), ii = 1, pd = 256, x = 1, y = 1, pix = #(), b = 0
	local colors = #()
	-- Open File
	f = try(fopen file "rbS")catch(undefined)
	
	-- Check File is Open
	if f != undefined then (
		-- Read File to VPT Object
		vpt.read_vpt_file(f)
		
		-- Read Textures
		for i = 1 to vpt.table3.count do (
			if vpt.table3[i].config == 3 do (
				
				-- Read Palette
				pal = #()
				pal[pd] = white
				fseek f vpt.table2[i][2].addr #seek_set
				for ii = 1 to pd do (
					pal[ii] = color (readbyte f #unsigned) (readbyte f #unsigned) (readbyte f #unsigned) (readbyte f #unsigned)
					
					-- Correct the Gamma
					pal[ii].red = correctGamma pal[ii].red
					pal[ii].green = correctGamma pal[ii].green
					pal[ii].blue = correctGamma pal[ii].blue
					pal[ii].alpha = correctGamma pal[ii].alpha
-- 					
-- 					-- Swap BGRA to RGBA
					pal[ii] = color pal[ii].a pal[ii].r pal[ii].g pal[ii].b
					)
				
				-- Order Palette (Required for 8Bit)
-- 				pal = correct_clut pal
				
				-- Read Image
				pix = #()
				pix[(vpt.table3[i].width * vpt.table3[i].height)] = 0
				fseek f vpt.table2[i][1].addr #seek_set
				for i = 1 to (vpt.table3[i].width * vpt.table3[i].height) do (
					pix[i] = readbyte f #unsigned
					)
				
				-- Unswizzle Image
				--pix = unswizzle_8bit pix vpt.table3[i].width vpt.table3[i].height
				colors = QImage_IMGD_Parse8 pix pal vpt.table3[i].width vpt.table3[i].height
				colors = QImage_IMGD_Decode8 colors vpt.table3[i].width
				--pix = QImage_IMGD_Decode8 pix vpt.table3[i].width
				
				-- Render Image (Combine Palette and Image Data)
				b = bitmap vpt.table3[i].width vpt.table3[i].height color:(color 255 0 255)
				for y = 1 to vpt.table3[i].height do (
					for x = 1 to vpt.table3[i].width do (
						setPixels b [x - 1, y - 1] #(colors[x + (vpt.table3[i].width * (y - 1))])
						)
					)
				
				display b
				)
			)
		
		fclose f
		) else (messagebox "Failed to Open File")
	)
main (
	"G:\\_HACKS&MODS\\SoulCalibur\\SC3_Playstation\\texture_sample1.vpt"
-- 	"G:\\_HACKS&MODS\\SoulCalibur\\SC3_Playstation\\File4.unk"
-- 	"G:\\_HACKS&MODS\\SoulCalibur\\SC3_Playstation\\07-0009-01.vxt"
	)